

//-----------------------------------------------------------------
//-----------------------------------------------------------------
//-----------------------------------------------------------------
//FUNCIONES DE los BLOCKS
//-----------------------------------------------------------------
//MATERIAL
material mat_ball_white		{ambient_blue =255;  ambient_green = 255; ambient_red = 255;}	
material mat_ball_verde		{ambient_blue = 50;  ambient_green = 255; ambient_red =  50;}	
material mat_ball_amarillo	{ambient_blue = 50;  ambient_green = 255; ambient_red = 255;}	
material mat_ball_rojo		{ambient_blue = 60;  ambient_green =  60; ambient_red = 190;}	
 
 
function ball_touch_block
{
  if (EVENT_TYPE == Event_impact) 
  {
    //ENT_playSOUND(MY,whamm,50);  	
   	vec_to_angle (you.pan, bounce.pan);
   	you.tilt = 0;	
		you.roll = 0;		
		
	if (my.material == mat_ball_verde)	
				{puntuacion += 200;}
						
	if (my.material == mat_ball_amarillo)
				{my.material = mat_ball_verde; puntuacion += 100; block_en_verde += 1;}
				
	if (my.material == mat_ball_rojo)
				{my.material = mat_ball_amarillo; puntuacion += 50;}
				
	if (my.material == mat_ball_white)
				{my.material = mat_ball_rojo; puntuacion += 20;}
  }
} 


//---------------------
function block_live
{
	my._ID = blocks_01;
	my.polygon = on;
	
	my.material = mat_ball_white;
	
	my.enable_impact = ON; 
  	my.EVENT = ball_touch_block;

}

//-----------------------------------------------------------------
//-----------------------------------------------------------------
//-----------------------------------------------------------------
//FUNCIONES DE LAS BOLAS
//-----------------------------------------------------------------
//-------------------------------------------
//linea de particulas
bmap fire_parmap	=	<fire.pcx>;
bmap humo_parmap	=	<humo.pcx>;

//controla su estado durante su vida
function fire_property_particle()
{
	//restarle vida y el tamao
	 my.alpha-= 1   *time_step;
	 my.size -= 0.5 *time_step;
	 
	 //cambiar de particula
	 if (my.alpha<=8){my.bmap=humo_parmap;}
	 
	 //se murio?
	 if (my.alpha<=0){my.lifespan=0;}
}

//inicia la particula
function fire_effect_particle()
{
	my.size= 30;
	my.bmap=fire_parmap;
	my.flare=on;
	my.bright=on;
	my.alpha=16;
	my.function=fire_property_particle;	
		
}// END TO fire_effect_corn
	
//-------------------------------------	
//MATERIAL
material mat_ball
{
	ambient_blue  = 128;	ambient_green  = 128;	ambient_red  = 256;
	diffuse_blue  = 120;	diffuse_green  = 120;	diffuse_red  = 220;
	emissive_blue = 5;	emissive_green = 5;		emissive_red = 5;
	specular_blue = 255;	specular_green = 255;	specular_red = 255;
	power = 10; 
 }	
		
//-------------------------------------
//eventos activados por la bola al chocar	
function bounce_event 
{
  if (EVENT_TYPE == EVENT_BLOCK) 
  {
    //ENT_playSOUND(MY,whamm,50);
   	vec_to_angle (my.pan, bounce.pan); // bounce direction
   	my.tilt = 0;	
		my.roll = 0; 
   	my.ball_speed += 3;//aumenta la velocidad
   	Return;		//Le hago volver lo antes posible
  }

  if (EVENT_TYPE == EVENT_ENTITY) //&& (you._id == ball)
  {
    //ENT_playSOUND(MY,whamm,50);  	
   	vec_to_angle (my.pan, bounce.pan);
   	my.tilt = 0;	
		my.roll = 0;
   	Return;//le hago volver lo antes posible 	     
  }
  
    if (EVENT_TYPE == EVENT_STUCK) 
  {
    	vec_inverse (my.pan);  
   	Return;//le hago volver lo antes posible 	     
  }
    
} 

//-------------------	
function ball_live()
{
	proc_late();
	var ball_speed_vec;
	
	my._ID = ball;
	
	//parametros fisicos
	my.pan =  random(360);	
	my.tilt = 0;	
	my.roll = 0; 
	
	//parametros visuales
	my.shadow = on;	
	my.light = ON;
	my.lightrange = 150; // 
	my.blue 	= 	130;
	my.red 	= 	160;
	my.green = 	80;
	
	my.material = mat_ball; 
		
	//parametros de control
	my.live_is 			= 	on;	//para saber cuando es eliminada	
	
	//Eventos
   my.ENABLE_BLOCK = ON; // make Entity sensitive for block collision
   my.ENABLE_ENTITY = ON; // make Entity sensitive for block collision
   my.ENABLE_STUCK = ON;
   my.ENABLE_SCAN = ON;
   my.EVENT = bounce_event;

	//while de movimiento
	while(my.live_is == on)
	{		
		//---------------
		//mantenerla en una altura fija.
		my.z = 288;	
			
		//---------------
		//time para mantener la misma distancia independiente del framerate
		my.ball_speed_x	=  ball_base_speed; //la velocidad puede cambiar
		ball_speed_vec.x = my.ball_speed* time_step;
		ball_speed_vec.y = 0;
		ball_speed_vec.z = 0;
		
		//Calcular velocidad
		vec_accelerate(ball_speed_vec,vector(0,0,0),my.ball_speed,0);
	
		//Time frame desajuste
		ball_speed_vec.x = (ball_speed_vec.x)/time_step;
		//dist.y = (ball_speed_vec.y)/time_step;	
		
		//I like move move
		c_move(my,ball_speed_vec,nullvector,Glide);
		
		//particulas
		effect(fire_effect_particle,100*time_step,my.x,my.pan);
		
		//estas muerto?
		if(my.live_is == off) {ent_remove(MY); break;}
		
		wait(1);
	}
		 total_de_balls -= 1;	//resto uno al numero de bolas que tienes
	   balls_in_game -= 1;	//resto uno al numero de bolas que hay en juego

	
}//END_TO: ball_live()

//-------------------
//carga la pelota y le asigna la function ball_live
var ofset = 256;
function ball_create()
{	
		balls_in_game + = 1; 		
		wait(-1);
		
		//evitamos que salgan en el mismo sitio
		if (ofset == 256){ofset = -256;}else{ofset = 256;}
		
		//aguantamos si hay alguien cerca de la posicion
		while (c_scan (Vector(0,ofset,288), vector(360,0,0), vector(360,360,256), SCAN_LIMIT) > 0 ){wait(1);}

		ent_create("ball.mdl",Vector(0,ofset,0), ball_live);
		
}

//-----------------------------------------------------------------	
//-----------------------------------------------------------------	
//-----------------------------------------------------------------
//FUNCIONES DE LAS PAREDES DE ELIMINACION DE BOLAS
//-----------------------------------------------------------------

function kill_balls_event 
{
  if (EVENT_TYPE == Event_impact) 
  {
   	//ENT_playSOUND(MY,whamm,50);	
   	//le informa a la pelota de que debe elimiarse en el siguiente ciclo
		you.live_is = off;
  }
}  
	
action kill_balls
{
	//La hago activa al impacto de otros modelos
	my.polygon = on;
	my._ID = killers_balls;
	my.enable_impact = ON; 
  	my.EVENT = kill_balls_event;
  	
}

//-----------------------------------------------------------------
//-----------------------------------------------------------------	
//-----------------------------------------------------------------
//FUNCIONES DE LOS PAD
//-----------------------------------------------------------------

//----------------------
//MATERIAL
material mat_stiks
{
ambient_blue = 225;
ambient_green = 200;
ambient_red = 200;

diffuse_blue = 200;
diffuse_green = 180;
diffuse_red = 180;

emissive_blue  = 5;
emissive_green = 5;
emissive_red   = 5;

specular_blue = 255;
specular_green = 255;
specular_red = 255;
power = 10; 
 }

//----------------------
//eventos si la bola choca contra el pad
function ball_touch 
{
  if (EVENT_TYPE == Event_impact) 
  {
    //ENT_playSOUND(MY,whamm,50);  	
   	vec_to_angle (you.pan, bounce.pan);
   	you.tilt = 0;	
		you.roll = 0;

  }
}  
	
//-------------------------------
//ACTION DEL mando derecho
action pad_right
{
	
	my._ID = pad;
	my.polygon = on;	//Hace que use la forma del objeto a la hora de golpear
			
	my.shadow = on;	
	my.light = ON;
	my.lightrange = 180;  
	my.blue 	= 	130;
	my.red 	= 	160;
	my.green = 	80;
	my.material = mat_stiks;
			 
	my.enable_impact = ON; 
  	my.EVENT = ball_touch;
  	
  	//variable con el movimiento a realziar			
  	var move_pad;
  	

	while(1)
	{
		//mover en la z
				
		//pad
		//move_pad += (joy_force.y);
				
		//teclas
		if (key_w) {move_pad =  2;}	
		if (key_s) {move_pad = -2;}
				
		//muve muve
		my.y += (move_pad * 70)* time_step;
		move_pad = 0;
		my.y = clamp(my.y, -400,400);	//pararle en los bordes
					
	wait(1);
	}
}
	
//-------------------------------
//ACTION DEL mando izquierdo
		
action pad_left
{
	
	my._ID = pad;
	
	my.polygon = on; //Hace que use la forma del objeto a la hora de golpear
	
	my.shadow = on;	
	my.light = ON;
	my.lightrange = 180; 
	my.blue 	= 	130;
	my.red 	= 	160;
	my.green = 	80;
	my.material = mat_stiks; 
	
	my.enable_impact = ON; 
	my.EVENT = ball_touch;
  			
	//algunos mandos no estan bien calibrados asi 
	//que usamos una variable con su calibracion	

	//variable con el movimiento a realziar		
	var move_pad;
				
	while(1)
	{								
		//el joy derecho no tiene joy_force asi que aqui esta el apao		
	//	if ((_joy_raw_z + 5) > joy_raw.z) 	{move_pad = 1;}
	//	if ((_joy_raw_z - 5) < joy_raw.z) 	{move_pad = -1;}	
	//	if (_joy_raw_z == joy_raw.z) 			{move_pad = 0;}	
						
		//teclas
		if (key_p) {move_pad = 1;}	
		if (key_l) {move_pad = -1;}
				
		//muve muve				
		my.y += (move_pad * 140)* time_step;
		move_pad = 0;		
		my.y = clamp(my.y, -400,400);	
						
	wait(1);
	}	
}
		
//imagen de fondo personalizada
/*
action on_off_fondo
{
	 if (on_off_fondo_var == on){my.invisible = off; }
}
*/
//-----------------------------------------------------------------
//
function ViGaMa()
{
	
  	//----------------------------------	
	//VirualGameMaster braindata
	var lock_V;//blokeador de aumento de la velocidad
	var lock_E;//blokeador de siguiente nivel	
	var nivel_acabado;//blokeador de aumento de la velocidad	
	var count;//contador para aoagar los paneles

	//un respiro nunca biene mal
  	wait(1);
	
	//desbloquea el nivel
	Freeze_mode = 0;
	ViGaMa_brain = on;
  	
  	//----------------------------------
	//VirualGameMaster brain
	while(ViGaMa_brain == on)
	{
		//Todas las fichas verdes)		
		//Si todas las fichas estan en verde activa doble bola e activa pasar al siguiente nivel
		if (block_en_verde == numero_bloques) && (lock_E == off)
					{
						lock_E = on; 
						playing_balls = 2; 
						total_de_balls = 1 + abs((total_de_balls * 3)); 
						nivel_acabado = on;
						str_cpy(game_data_string,doble_ball_string);
						game_data_panel.visible = on;	
						game_data_back_panel.visible = on;
					}// freeze_mode = 2;	
					
		if (lock_E == on) && (count < 520)
		{
			count + = 1;
			
			if (count == 500)
					{game_data_panel.visible = off; game_data_back_panel.visible = off;}
		}			
						

		//Fin de la partida?
		//Si no estan todas las fichas en verde palmaste	
		if (total_de_balls <= 0){break;}//sale al final de while
			
		//Cargar bola nueva si hay menos de las deberia	
		if(balls_in_game < playing_balls){ball_create();}
			
		//Aumentar la velocidad de la pelota dependiendo de la dificultad/puntuacion
		if (puntuacion > up_dificult) && (lock_V == 0) 
			{ball_base_speed =  ball_base_speed + aumento_de_velocidad; lock_V = 1; up_dificult = up_dificult + multiplic_dificult;}
			
		if (puntuacion > up_dificult) && (lock_V == 1)
			 {ball_base_speed =  ball_base_speed + aumento_de_velocidad; lock_V = 2; up_dificult = up_dificult + multiplic_dificult;}
			 	
		if (puntuacion > up_dificult) && (lock_V == 2) 
			{ball_base_speed =  ball_base_speed + aumento_de_velocidad; lock_V = 3; up_dificult = up_dificult + multiplic_dificult;}
				
		if (puntuacion > up_dificult) && (lock_V == 3)
			 {ball_base_speed =  ball_base_speed + aumento_de_velocidad; lock_V = 4; up_dificult = up_dificult + multiplic_dificult;}
			 
		if (puntuacion > up_dificult) && (lock_V == 4) 
			{ball_base_speed =  ball_base_speed + aumento_de_velocidad; lock_V = 5; up_dificult = up_dificult + multiplic_dificult;}

	wait(1);	
	}
	//al hacer el break llega aqui	
	//si todas las fichas estan en verde	
	if (nivel_acabado == on){siguiente_nivel();}	
	//sino
	if (nivel_acabado == off){level_over();}
	
}
