//-----------------------------------------------------------
//-----------------------------------------------------------
//-----------------------------------------------------------
path "bin";

include <data_panels.wdl>;			//Gameplay del juego 01
include <game_01_gameplay.wdl>;	//Gameplay del juego 01
include <game_01_END.wdl>;			//Fin de la partida
include <game_01_star.wdl>;		//Carga el juego 01

//-----------------------------------------------------------
function play_game_01()
{
	ViGaMa_brain = off;
	star_panel.visible = off;
	star_panel_bak.visible = off;
	record_panel.visible = off;
	record_panel_bak.visible = off;
	main_game_01();
		
}

function rules()
{
	rules_panel.visible = on;
	rules_panel_bak.visible = on;	
	record_panel.visible = off;
	record_panel_bak.visible = off;	
	star_panel.visible = off;
	star_panel_bak.visible = off;
		
}

function back_main_window()
{
	rules_panel.visible = off;	
	rules_panel_bak.visible = off;	
	record_panel.visible = on;
	record_panel_bak.visible = on;
	star_panel.visible = on;
	star_panel_bak.visible = on;		
}

function gexit()
{
	game_save("records_",0,SV_STRINGS | SV_INFO);
	wait(-0.4);
	sys_exit("I see you...");
}

function main_window()
{		
	freeze_mode = 1;	
	level_load("level_game_01.wmb");
	wait(1);

	panel_game_01_up.visible = on;
	panel_game_01_low.visible = on;
	camera.x = 0;		
	camera.y = 0;		
	camera.z = 1800;
	camera.pan = 90;			
	camera.tilt = -90;	
	camera.arc = 64;
	//splases (publicidad inicial)
	if (star_ == on)
	{
	star_back_panel.visible = on;
	wait(-0.5);
	star_info_panel.TRANSLUCENT = on;		
	star_info_panel.visible = on;	
	wait(-3);	
	star_info_panel.visible = off;
	star_back_panel.TRANSLUCENT = on;
	wait(-0.5);		
	star_back_panel.visible = off;
	}
	star_ = off;
	back_main_window();
	
}

//----------------------------------
//funcion principal es la priera funcion del juego 
function main
{

	//algunos mandos no estan bien calibrados asi que... 		
		_joy_raw_z = joy_raw.z;	
		game_load("records_",0);
		video_set(800, 650, 32, 0);
		
	//-----------------------				
		cargar_game_data_inicial();
		wait(1);
	//-----------------------		
		main_window();				

}

//-------------------------------------------

//instruciones keyboard 
on_1 = play_game_01;
on_2 = rules;
on_space = back_main_window;
on_esc = game_over;
on_E = gexit;
on_f5 = null;


//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------
panel debug_panel_01
{
//-------------------------------------------------
layer	200; pos_x 0; pos_y 0; //flags = visible;		
//-------------------------------------------------

digits 10,160,"joy_raw.x %.f",arial_25,1,joy_raw.x;
digits 10,175,"joy_raw.y %.f",arial_25,1,joy_raw.y;
digits 10,190,"joy_raw.z %.f",arial_25,1,joy_raw.z;

//digits 10,260,"_joy_raw_z %.f",arial_25,1,_joy_raw_z;

digits 10,360,"joy_rot.x %.f",arial_25,1,joy_rot.x;
digits 10,375,"joy_rot.y %.f",arial_25,1,joy_rot.y;
digits 10,390,"joy_rot.z %.f",arial_25,1,joy_rot.z;

/*
digits 10,200,"total_de_balls  %.f",arial_gigant,1,total_de_balls;
digits 10,220,"block_en_rojo  %.f",arial_gigant,1,block_en_rojo;
digits 10,240,"v  %.f",arial_gigant,1,back_to_verde;
*/
}